"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.postSave = void 0;
async function postSave(doc) {
    var _a;
    if (doc && doc.esOptions) {
        const data = doc._mexp || {};
        const esOptions = doc.esOptions();
        delete doc._mexp;
        if (!esOptions.filter || esOptions.filter(doc)) {
            try {
                let res = await doc.esIndex(data.wasNew ? false : { unset: data.unset });
                res =
                    esOptions.script && ((_a = data.unset) === null || _a === void 0 ? void 0 : _a.length) ? doc.esUnset(data.unset) : res;
                doc.emit('es-indexed', undefined, res);
                doc.constructor.emit('es-indexed', undefined, res);
            }
            catch (err) {
                doc.emit('es-indexed', err);
                doc.constructor.emit('es-indexed', err);
            }
        }
        else {
            doc.emit('es-filtered');
            doc.constructor.emit('es-filtered');
            if (!data.wasNew) {
                const res = await doc.esRemove();
                doc.emit('es-removed', res);
                doc.constructor.emit('es-removed', res);
            }
        }
    }
}
exports.postSave = postSave;
//# sourceMappingURL=post-save.js.map