"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Mongoosearch = void 0;
const lodash_1 = require("lodash");
const methods_1 = require("./methods");
const es_create_mapping_1 = require("./statics/es-create-mapping");
const es_exists_1 = require("./statics/es-exists");
const es_delete_index_1 = require("./statics/es-delete-index");
const es_count_1 = require("./statics/es-count");
const es_sync_1 = require("./statics/es-sync");
const es_search_1 = require("./statics/es-search");
const es_refresh_1 = require("./statics/es-refresh");
const es_unset_1 = require("./statics/es-unset");
const es_remove_1 = require("./statics/es-remove");
const post_remove_1 = require("./hooks/post-remove");
const post_save_1 = require("./hooks/post-save");
const pre_save_1 = require("./hooks/pre-save");
function Mongoosearch(schema, options) {
    if (!options.client)
        return;
    options = (0, lodash_1.cloneDeep)(options);
    schema.__ELASTIC = true;
    schema.statics.esCount = es_count_1.esCount;
    schema.statics.esCreateMapping = es_create_mapping_1.esCreateMapping;
    schema.statics.esDeleteIndex = es_delete_index_1.esDeleteIndex;
    schema.statics.esExists = es_exists_1.esExists;
    schema.statics.esOptions = (0, methods_1.esOptions)(options);
    schema.statics.esRefresh = es_refresh_1.esRefresh;
    schema.statics.esSearch = es_search_1.esSearch;
    schema.statics.esSync = es_sync_1.esSync;
    schema.methods.esIndex = methods_1.esIndex;
    schema.methods.esOptions = (0, methods_1.esOptions)(options);
    schema.methods.esRemove = es_remove_1.esRemove;
    schema.methods.esUnset = es_unset_1.esUnset;
    if (!options.manual) {
        schema.pre('save', pre_save_1.preSave);
        schema.post('save', post_save_1.postSave);
        schema.post('findOneAndUpdate', post_save_1.postSave);
        schema.post('remove', post_remove_1.postRemove);
        schema.post('findOneAndRemove', post_remove_1.postRemove);
    }
}
exports.Mongoosearch = Mongoosearch;
//# sourceMappingURL=mongoosearch.js.map