"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.esSearch = void 0;
const utils = __importStar(require("../utils"));
const lodash_1 = require("lodash");
const bson_1 = require("bson");
async function esSearch(query = {}, options = {}) {
    const esOptions = this.esOptions();
    const hydrate = options.hydrate === false ? false : options.hydrate || esOptions.hydrate;
    const idsOnly = options.idsOnly === false ? false : options.idsOnly || esOptions.idsOnly;
    const params = {
        index: esOptions.index,
        type: esOptions.type,
    };
    if ((0, lodash_1.isString)(query)) {
        params.q = query;
    }
    else {
        params.body = query.query ? query : { query };
    }
    if (hydrate) {
        params._source = false;
    }
    let result = await esOptions.client.search(params);
    if (!hydrate && !idsOnly) {
        return result;
    }
    const isObjectId = utils.getType(this.schema.paths._id) === 'objectid';
    const ids = result.hits.hits.map(hit => isObjectId ? new bson_1.ObjectId(hit._id) : hit._id);
    if (idsOnly) {
        return ids;
    }
    const { select = undefined, opts = undefined, docsOnly = false, } = hydrate !== null && hydrate !== void 0 ? hydrate : {};
    if (!result.hits.total) {
        return docsOnly ? [] : result;
    }
    let _query = this.find({ _id: { $in: ids } }, select, opts);
    if (hydrate.populate) {
        _query = _query.populate(hydrate.populate);
    }
    const docs = await _query;
    const docsById = new Map();
    docs.forEach(doc => {
        docsById.set(doc._id, doc);
    });
    if (docsOnly) {
        result = Array.from(docsById.values());
    }
    else {
        result.hits.hits.forEach(hit => {
            hit.doc = docsById.get(hit._id);
        });
    }
    return result;
}
exports.esSearch = esSearch;
//# sourceMappingURL=es-search.js.map