"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.esUnset = void 0;
async function esUnset(fields) {
    const esOptions = this.esOptions();
    let body;
    const fields$ = Array.isArray(fields) ? fields : [fields];
    if (esOptions.script) {
        body = {
            script: fields$.map(field => `ctx._source.remove("${field}")`).join(';'),
        };
    }
    else {
        body = { doc: {} };
        fields$.forEach(field => {
            body.doc[field] = null;
        });
    }
    return esOptions.client.update({
        index: esOptions.index,
        id: this._id.toString(),
        body,
    });
}
exports.esUnset = esUnset;
//# sourceMappingURL=es-unset.js.map